Bug 1500818 - Can't upgrade Puppet 3 to Puppet 4 on Capsule
Summary: Can't upgrade Puppet 3 to Puppet 4 on Capsule
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Satellite
Classification: Red Hat
Component: Installer
Version: 6.3.0
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: Unspecified
Assignee: Eric Helms
QA Contact: Lukas Pramuk
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-10-11 14:31 UTC by Lukáš Hellebrandt
Modified: 2019-09-26 14:49 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Foreman Issue Tracker 21321 Normal Closed Can't upgrade Puppet 3 to Puppet 4 on Capsule 2019-12-19 07:22:56 UTC
Foreman Issue Tracker 21433 Normal Closed Puppet 3 to Puppet 4 upgrade fails on Capsule 2019-12-19 07:22:56 UTC

Description Lukáš Hellebrandt 2017-10-11 14:31:00 UTC
Description of problem:
Running
# satellite-installer --scenario capsule --upgrade-puppet
or
# satellite-installer --upgrade-puppet
on Capsule leads to error: "Puppet 3 to 4 upgrade is not currently supported for the chosen scenario."

Version:
Tried with Sat6.3 snap 19.

How reproducible:
Deterministic

Steps to Reproduce:
1. On a Capsule, run # satellite-installer --scenario capsule --upgrade-puppet

Actual results:
Error

Expected results:
Upgrade from Puppet 3 to 4 should work

Comment 2 Eric Helms 2017-10-13 14:55:52 UTC
Created redmine issue http://projects.theforeman.org/issues/21321 from this bug

Comment 3 pm-sat@redhat.com 2017-10-13 16:13:30 UTC
Upstream bug assigned to ehelms@redhat.com

Comment 4 pm-sat@redhat.com 2017-10-13 16:13:34 UTC
Upstream bug assigned to ehelms@redhat.com

Comment 5 Lukas Pramuk 2017-10-23 09:11:31 UTC
FailedQA.

@satellite-capsule-6.3.0-21.0.beta.el7sat.noarch
puppet-agent-1.10.7-1.el7sat.x86_64
puppetserver-2.8.0-1.el7sat.noarch

@Capsule:

# satellite-installer --upgrade-puppet
Upgrading puppet...
...

Upgrade Step: upgrade_puppet_package...
...

Upgrade Step: stop_services...
...

Upgrade Step: copy_data...
...

Upgrade Step: remove_puppet_port_httpd...
...

Upgrade Step: start_httpd...
/usr/sbin/service-wait httpd start
Redirecting to /bin/systemctl start httpd.service

Success!
katello-service start --only httpd finished successfully!
Puppet 3 to 4 upgrade initialization complete, continuing with installation
Resetting puppet params...
/usr/share/katello-installer-base/hooks/boot/01-helpers.rb:59:in `reset_value': undefined method `unset_value' for nil:NilClass (NoMethodError)
	from /usr/share/katello-installer-base/hooks/pre_validations/31-upgrade-puppet.rb:19:in `block (4 levels) in load'
	from /usr/share/gems/gems/kafo-2.0.0/lib/kafo/hooking.rb:34:in `instance_eval'
	from /usr/share/gems/gems/kafo-2.0.0/lib/kafo/hooking.rb:34:in `block (4 levels) in load'
	from /usr/share/gems/gems/kafo-2.0.0/lib/kafo/hook_context.rb:15:in `instance_exec'
	from /usr/share/gems/gems/kafo-2.0.0/lib/kafo/hook_context.rb:15:in `execute'
	from /usr/share/gems/gems/kafo-2.0.0/lib/kafo/hooking.rb:51:in `block in execute'
	from /usr/share/gems/gems/kafo-2.0.0/lib/kafo/hooking.rb:49:in `each'
	from /usr/share/gems/gems/kafo-2.0.0/lib/kafo/hooking.rb:49:in `execute'
	from /usr/share/gems/gems/kafo-2.0.0/lib/kafo/kafo_configure.rb:140:in `execute'
	from /usr/share/gems/gems/clamp-1.0.0/lib/clamp/command.rb:68:in `run'
	from /usr/share/gems/gems/kafo-2.0.0/lib/kafo/kafo_configure.rb:119:in `run'
	from /usr/share/gems/gems/clamp-1.0.0/lib/clamp/command.rb:133:in `run'
	from /usr/share/gems/gems/kafo-2.0.0/lib/kafo/kafo_configure.rb:163:in `run'
	from /usr/sbin/satellite-installer:8:in `<main>'

Comment 8 Lukas Pramuk 2017-10-31 11:06:35 UTC
FailedQA.

@satellite-capsule-6.3.0-21.0.beta.el7sat.noarch
satellite-installer-6.3.0.9-1.beta.el7sat.noarch
katello-installer-base-3.4.5.10-1.el7sat.noarch

# head -25 /usr/share/katello-installer-base/hooks/pre_validations/31-upgrade-puppet.rb | tail
  Kafo::Helpers.log_and_say :info, 'Resetting puppet params...'

  if !app_value(:noop)
    Kafo::Helpers.reset_value(param('foreman', 'puppet_home'))
    Kafo::Helpers.reset_value(param('foreman', 'puppet_ssldir'))
    Kafo::Helpers.reset_value(param('foreman_proxy', 'puppet_ssl_ca'))
    Kafo::Helpers.reset_value(param('foreman_proxy', 'puppet_ssl_cert'))
    Kafo::Helpers.reset_value(param('foreman_proxy', 'puppet_ssl_key'))
    Kafo::Helpers.reset_value(param('foreman_proxy', 'puppetdir'))
    Kafo::Helpers.reset_value(param('foreman_proxy', 'ssldir'))


>>> fix is not present in snap22

Comment 9 Lukas Pramuk 2017-11-03 12:44:29 UTC
VERIFIED.

@satellite-capsule-6.3.0-21.0.beta.el7sat.noarch
katello-installer-base-3.4.5.11-1.el7sat.noarch

by following manual reproducer:

@CAPSULE
# satellite-installer -S capsule --upgrade-puppet
Upgrading puppet...
...

Puppet 3 to 4 upgrade initialization complete, continuing with installation
Resetting puppet params...
Puppet 3 to 4 upgrade param reset, continuing with installation
Installing             Done                                               [100%] [.....................................]
  Success!
  * Capsule is running at https://cap.example.com:9090
  The full log is at /var/log/foreman-installer/capsule.log
Upgrade Step: restart_services...
...

Success!
katello-service restart finished successfully!


>>> capsule puppet upgrade finished successfully

Comment 10 Bryan Kearney 2018-02-21 17:34:18 UTC
Since the problem described in this bug report should be resolved in a recent advisory, it has been closed with a resolution of ERRATA.

For information on the advisory, and where to find the updated files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2018:0336

Comment 11 Bryan Kearney 2018-02-21 17:34:20 UTC
Since the problem described in this bug report should be resolved in a recent advisory, it has been closed with a resolution of ERRATA.

For information on the advisory, and where to find the updated files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2018:0336


Note You need to log in before you can comment on or make changes to this bug.